﻿Imports FluentNHibernate.Mapping

Public Class AddressMap
    Inherits ClassMap(Of nHibernate.Models.AddressModel)

    Public Sub New()
        '### ID ###'
        Id(Function(x) x.CustomerID)

        '### Properties ###'
        Map(Function(x) x.Salutation)
        Map(Function(x) x.Title)
        Map(Function(x) x.Forname)
        Map(Function(x) x.Surname)
        Map(Function(x) x.Street)
        Map(Function(x) x.No)
        Map(Function(x) x.Addition)
        Map(Function(x) x.ZipCode)
        Map(Function(x) x.City)
        Map(Function(x) x.Country)
        Map(Function(x) x.CompanyName)
    End Sub
End Class
Public Class EAddressMap
    Inherits ClassMap(Of nHibernate.Models.EAddressModel)

    Public Sub New()
        '### ID ###'
        Id(Function(x) x.EAddressID)

        '### Properties ###'
        Map(Function(x) x.AddressDescription)
        Map(Function(x) x.Salutation)
        Map(Function(x) x.Title)
        Map(Function(x) x.Forname)
        Map(Function(x) x.Surname)
        Map(Function(x) x.Street)
        Map(Function(x) x.No)
        Map(Function(x) x.Addition)
        Map(Function(x) x.ZipCode)
        Map(Function(x) x.City)
        Map(Function(x) x.Country)
        Map(Function(x) x.CompanyName)
    End Sub
End Class
Public Class DeliveryAddressMap
    Inherits ClassMap(Of nHibernate.Models.DeliveryAddressModel)

    Public Sub New()
        '### ID ###'
        Id(Function(x) x.GUID)

        '### Properties ###'
        Map(Function(x) x.Salutation)
        Map(Function(x) x.Title)
        Map(Function(x) x.Forname)
        Map(Function(x) x.Surname)
        Map(Function(x) x.Street)
        Map(Function(x) x.No)
        Map(Function(x) x.Addition)
        Map(Function(x) x.ZipCode)
        Map(Function(x) x.City)
        Map(Function(x) x.Country)
        Map(Function(x) x.CompanyName)
    End Sub
End Class

Public Class ContactMap
    Inherits ClassMap(Of nHibernate.Models.ContactModel)

    Public Sub New()
        '### ID ###'
        Id(Function(x) x.CustomerID)

        '### Properties ###'
        Map(Function(x) x.Facebook)
        Map(Function(x) x.Mail1)
        Map(Function(x) x.Mail2)
        Map(Function(x) x.Mobil1)
        Map(Function(x) x.Mobil2)
        Map(Function(x) x.Telefax1)
        Map(Function(x) x.Telefax2)
        Map(Function(x) x.Telefon1)
        Map(Function(x) x.Telefon2)
        Map(Function(x) x.Twitter)
        Map(Function(x) x.Website)
    End Sub
End Class
