﻿Imports FluentNHibernate.Mapping

Public Class OrderedArticleMap
    Inherits ClassMap(Of nHibernate.Models.OrderedArticleModel)

    Public Sub New()
        '### Id ###'
        Id(Function(x) x.OrderArticleIDWithOrderID)

        '### Properties ###'
        Map(Function(x) x.OrderArticleID)
        Map(Function(x) x.OrderedAmount)
        Map(Function(x) x.OrderRebate)
        Map(Function(x) x.OrderPriceAmount)
        Map(Function(x) x.OrderPriceIsGross)
        Map(Function(x) x.OrderPriceCurrency)
        Map(Function(x) x.OrderPosition)
        Map(Function(x) x.OrderText)

        '### References ###'
        References(Function(x) x.Article).Not.LazyLoad()
    End Sub
End Class
