﻿Imports System.Drawing

Public Class BarCodeStroke
    Private _color As System.Windows.Media.Color
    Private _doublewidth As Boolean

    Public ReadOnly Property IsDoubleWidth As Boolean
        Get
            Return _doublewidth
        End Get
    End Property

    Public Sub New(IsDoubleWidth As Boolean)
        _doublewidth = IsDoubleWidth
    End Sub

    Public Sub New(IsDoubleWidth As Boolean, Colour As System.Windows.Media.Color)
        _doublewidth = IsDoubleWidth
        _color = Colour
    End Sub

    Public Sub New(Colour As System.Windows.Media.Color)
        _color = Colour
    End Sub

    Public Sub New(item As BarCodeStroke, Colour As System.Windows.Media.Color)
        _doublewidth = item.IsDoubleWidth
        _color = Colour
    End Sub

    Public Property Color As System.Windows.Media.Color
        Get
            Return _color
        End Get
        Set(value As System.Windows.Media.Color)
            _color = value
        End Set
    End Property
End Class