﻿Imports FluentNHibernate.Mapping

Public Class CategoryMap
    Inherits ClassMap(Of Category)

    Public Sub New()
        '### Properties ###'
        Id(Function(x) x.CID)

        Map(Function(x) x.Name)
        '### References ###'
        HasMany(Function(x) x.Children).Not.LazyLoad()
        References(Function(x) x.DefaultTax).Not.LazyLoad()
        References(Function(x) x.Parent).Not.LazyLoad()
    End Sub
End Class
