Imports System.Collections.Generic
Imports System.Linq
Imports System.Text
Imports System.Windows.Controls
Imports Biller.core
Imports Biller.provider

Namespace control
	Public Class AutoCompleteTextBox
		Inherits TextBox
		Private _acm As AutoCompleteManager

		Public ReadOnly Property AutoCompleteManager() As AutoCompleteManager
			Get
				Return _acm
			End Get
		End Property

		Public Sub New()
			_acm = New AutoCompleteManager()
			_acm.DataProvider = New FileSysDataProvider()
			AddHandler Me.Loaded, AddressOf AutoCompleteTextBox_Loaded
		End Sub

		Private Sub AutoCompleteTextBox_Loaded(sender As Object, e As System.Windows.RoutedEventArgs)
			_acm.AttachTextBox(Me)
		End Sub

	End Class
End Namespace
